<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

echo "les fonctions <br /><br />";

/**
 * Fonction sans paramètre qui affiche "Bonjour !"
 *
 * pas de valeur de retour.
 * 
 */
function afficheHello()
{ 
  echo "Bonjour !<br />"; 
} 



/**
 * Fonction avec 2 paramètres qui retourne le produit
 * des deux paramètres. 
 */
function multiplieValeurs($nVal1, $nVal2)
{ 
  return $nVal1 * $nVal2; 
} 



// Appel de la fonction afficheHello. 
afficheHello(); 


// Utilisations de la fonction multiplieValeurs

// - dans une affectation 
$nResult = multiplieValeurs(2,4); 
echo "2 x 4 = ".$nResult."<br />"; 

// - dans une comparaison 
if (multiplieValeurs(10,12) > 100)
{ 
  echo "10 x 12 est superieur a 100.<br />"; 
} 





// exemple avec une valeur de retour comme un tableau

/**
 * Définition d’une fonction qui retourne un tableau.
 * @return [type] [description]
 */
function getIdentite()
{ 
  return ["Matthieu","Developpement"]; 
} 

// Appel de la fonction et récupération directe de la valeur
echo "qui = ".getIdentite()[0]."<br />"; 




// Les fonctions " variable ""

/**
 * Fonction qui effectue une multiplication.
 * @param  [type] $nVal1 [description]
 * @param  [type] $nVal2 [description]
 * @return [type]          [description]
 */
function getProduit($nVal1,$nVal2)
{ 
	return ($nVal1 * $nVal2); 
} 


/**
 * Fonction qui effectue une addition.
 * @param  [type] $nVal1 [description]
 * @param  [type] $nVal2 [description]
 * @return [type]          [description]
 */
function getSomme($nVal1,$nVal2)
{ 
  	return ($nVal1 + $nVal2); 
} 


/**
 * Fonction qui effectue un calcul,
 * le nom du calcul est passé en paramètre. 
 * 
 */
function getCalcul($name_operation, $nVal1, $nVal2)
{ 
  // $name_operation contient le nom de la fonction 
  // à exécuter => appel $name_operation(). 
  return ($name_operation($nVal1, $nVal2)); 
} 

// Utilisation de la fonction calculer. 
echo "<br />3 + 5 = ".getCalcul('getSomme', 3, 5)."<br />"; 
echo "3 * 5 = ".getCalcul('getProduit', 3, 5)."<br /><br />"; 


// passage par référence


/**
 * Définition d'une fonction qui prend un paramètre.
 * @param  [type] $paramètre [description]
 * @return [type]            [description]
 */
function parReference(&$nValue)
{ 
  $nValue++; 
  // Affichage de la valeur
  echo "Valeur function = ".$nValue."<br />"; 
} 

// Initialisation d’une variable. 
$nVal = 3; 

echo "avant appel = ".$nVal."<br />"; 

// Appel de la fonction en utilisant la variable comme valeur
parReference($nVal); 

// Affichage de la variable après l'appel à la fonction. 
echo "apres appel = ".$nVal."<br /><br />"; 




// les paramètres

/**
 * Fonction qui accepte un premier paramètre par référence
 * et qui y stocke le produit de tous les autres paramètres. 
 */
function getMultiple(&$nResult)
{ 
	// en fonction du nombre d'arguments de la fonction
	switch (func_num_args())
	{ 
		case 1:  
			// Un seul paramètre
			// Retourner 0. 
			$nResult = 0; 
			break; 

		default:  
			// Récupérer les paramètres dans un tableau 
			// et supprime le premier paramètre. 
			$aParam = func_get_args(); 
			unset($aParam[0]); 
			
			$nResult = 1; // Initialiser le résultat à 1. 

			// boucle sur le tableau des paramètres 
			// pour multiplier le résultat par le paramètre. 
			foreach($aParam as $paramètre)
			{ 
				$nResult *= $paramètre; 
			} 
	} 
} 

$nValeur = 0;
getMultiple($nValeur); 
echo "produit($nValeur) => ".$nValeur."<br />"; 

getMultiple($nValeur, 1, 2, 3); 
echo "produit(nValeur,1,2,3) => ".$nValeur."<br />"; 






?>
